<?php include("header.phtml"); ?>

<script type="text/javascript" src="js/rsh.compressed.js"></script>

<div id="player-container"></div>

<script type="text/javascript">

var player;

(function() {
    
    // Provide handlers for frontend things (page title, permalinks) that
    // aren't handled by Player directly
    var hooks = {
        initGame: function() {
            document.title = "EidoGo - " + this.getGameDescription();
        },
        setPermalink: function() {
            if (!this.gameName || ['search', 'gnugo', 'url'].contains(this.gameName)) return;
            var gn = this.gameName || "";
            // use move-based path for KJD to future-proof permalinks
            var path = (gn == "kjd" ?
                this.cursor.getPathMoves().join("") :
                this.cursor.getPath().join(","));
            var hash = gn + (path ? ":" + path : "");
            addHistory(hash);
        },
        searchRegion: function(params) {
            this.hooks.initGame.call(this); // update title
            var hash = "search:" + params.q + ":" + params.w + "x" + params.h +
                ":" + this.compressPattern(params.p);
            if (params.a && params.a != "corner") hash += ":" + params.a;
            if (hash != location.hash.replace(/^#/, "")) {
                addHistory(hash);
            }
        },
        saved: function(gn) {
            loadGame({gameName: gn, loadPath: [0,0]}, function() {
                var url = location.href.replace(/#[^#]+$/, "") + "#" + this.gameName;
                this.setPermalink();
                this.prependComment("Game saved to <a href='" + url + "'>" + url + "</a>");
            }.bind(this));
        }
    };
    
    // Load game data; create a Player instance if necessary
    function loadGame(params, completeFn) {
        params = params || {};
        var cfg = {
            progressiveLoad:    false,
            markCurrent:        true,
            markVariations:     true,
            markNext:           false,
            showGameInfo:       true,
            showPlayerInfo:     true,
            showOptions:        true,
            showTools:          true,
            problemMode:        false
        };
        for (var key in params) {
            cfg[key] = params[key];
        }
        if (!player) {
            player = new eidogo.Player({
                container:          "player-container",
                sgfPath:            "sgf/",
                searchUrl:          "php/search.php",
                saveUrl:            "php/save.php",
                downloadUrl:        "php/download.php?id=",
                scoreEstUrl:        "php/gnugo.php",
                hooks:              hooks,
                enableShortcuts:    true
            });
        }
        player.loadSgf(cfg, completeFn);
    }
    
    var notLoaded = true;
    
    function loadState(hash) {
        notLoaded = false;
        var hashParts = hash ? hash.replace(/^#/, "").split(/:/) : [];
        var gameName = hashParts[0] || "";
        var loadPath = hashParts[1] ? hashParts[1].split(",") : null;
        var rest = hashParts.slice(1);
        if (!gameName || gameName == "kjd") {
            if (loadPath) {
                var s = loadPath[0];
                var coord;
                loadPath = [];
                while (coord = s.substring(0, 2)) {
                    loadPath.push(coord);
                    s = s.substring(2);
                }
            }
            loadGame({
                gameName:           "ojd",
                sgfUrl:             "php/ojd_progressive.php",
		commitUrl:          "php/ojd_commit.php",
                loadPath:           loadPath,
                progressiveLoad:    true,
                markNext:           true,
                showPlayerInfo:     false,
                showOptions:        false
            });
            return;
        }
        if (gameName == "url") {
            loadGame({
                gameName:   "url",
                sgfUrl:     "php/fetch.php?url=" + hash.replace(/^#?url:/, "")
            });
            return;
        }
        if (gameName == "search") {
            if (loadPath) {
                loadGame({showOptions: false});
                player.loadSearch.apply(player, rest);
            } else {
                loadGame({
                    gameName:    "search",
                    showOptions: false,
                    loadPath:    [0,0]
                });
            }
            return;
        }
        if (gameName.indexOf("gnugo") === 0) {
            var params = {
                gameName:       "",
                opponentUrl:    "php/gnugo.php",
                opponentColor:  "B"
            };
            var parts = gameName.split("-");
            if (parts[1]) {
                params.boardSize = parts[1];
            }
            loadGame(params);
            return;
        }
        loadGame({
            gameName:   gameName,
            loadPath:   loadPath
        });
    }
    
    function addHistory(hash) {
        if (dhtmlHistory.isSafari) {
            // Safari 2 sucks
            location.hash = hash;
        } else {
            dhtmlHistory.add(hash);
        }
    }
    
    // appease RSH
    window.dhtmlHistory.create({
        toJSON: function(o) { return ''; },
        fromJSON: function(s) { return {}; }
    });
    

    // ajaxify our links
    eidogo.util.addEvent(document, "click", function(evt) {
        var target = eidogo.util.getTarget(evt)
        if (target.nodeName.toUpperCase() != "A" || target.href.indexOf("#") == -1) return true;
        var hash = target.href.replace(/^.*#/, "");
        addHistory(hash);
        player.closeSearch();
        loadState(hash);
        eidogo.util.stopEvent(evt);
    });
    
    dhtmlHistory.initialize();
    dhtmlHistory.addListener(loadState);
    
    if (notLoaded) {
        // make sure we load our state on first page load (RSH quirk)
        loadState(location.hash.replace(/^#/, ""));
    }
    
})();

</script>

<?php include("footer.phtml"); ?>
